rem conversion listing MO5 Island vers VG5000
rem =========================================

rem Attention, ce source n'est adapte que pour convertir ISLAND MO5
rem vers une version compatible VG5000 'brute de fonderie' (gestion des couleurs en particulier)
rem Si vous comptez l'utiliser pour adapter d'autres programmes BASIC simples,
rem il y aura probablement des adaptations  faire

rem C'est tres moche au niveau du code, mais cela fonctionne a peu pres :-).

dim dummy

dim listing(10000) ' tableau ou sera stocke le listing  convertir
dim symbol (10) ' tableau pour le traitement des parametres des commandes de redifinition de caracteres
dim ligne

Dim files 
dim file_source

dim i,j,k,l,m

decalage_symbol=48
longueur_ligne=120

'on error resume next

rem Initialisation du systeme de fichiers
rem =====================================

Set fso=WScript.CreateObject("Scripting.FileSystemObject")

file_source = ".\island_mo5.txt"
file_destination = ".\island_vg5000.txt"


rem Lecture du fichier source dans un tableau
rem =========================================

Set sourcefile = fso.GetFile(file_source)
Set InputFile = sourcefile.OpenAsTextStream(1)

ligne=0

Do While inputfile.AtEndOfStream = False

	dummy=inputfile.readline
	ligne=ligne+1
	listing(ligne)=dummy	
loop

inputfile.close

rem Conversion des DEF GR$ en SETEG
rem ===============================

for i=1 to ligne

	Do while instr(listing(i),"DEF GR$(")>0
	
		j=instr(listing(i),"DEF GR$(" )' on recherche les bornes de la commade DEF GR$
		k=instr(j,listing(i),")")
		l=MID(listing(i),j+8,k-j-8)
		m=clng(l)+decalage_symbol	' premier caractere redefini, 48
									' Permettra de remplacer les sequences CHR$() par des caracteres pour gagner de la memoire
									' et de la vitesse d'affichage
									' ex :PRINT GR$(0);GR$(1);GR$(2) devient PRINT "123"
									' Le listing part du principe que toutes les commandes de couleurs sont graphiques.
									' Il faudra ensuite remplacer manuellement les commandes inapropries pour afficher des
									' textes.
			
		tempo=mid(listing(i),k+2,len(listing(i))-k+3)
		
		FOR n=1 TO 7
			o=instr(tempo,",")
			symbol(n)=clng(left(tempo,o-1))
			tempo=mid(tempo,o+1,len(tempo)-o)
		next 
		
		symbol(8)=clng(tempo)

		' inversion des caracteres pour le VG5000 
		' but, eviter d'utiliser des espaces pour les graphismes, ce qui pose de grossses
		' contraintes d'affichage (le fond sur VG5000 se repercute sur tout la ligne 
		' quand on affiche un caractere, merci Philips & Thomson).
		
		for n=1 to 8
			'symbol(n)=255-symbol(n)
		next
		
		dummy=mid(listing(i),1,j-1)+"SETEG "+CSTR(m)+","+chr(34)
		for n=1 to 8
		tempo=hex(symbol(n))
		if len(tempo)<2 then tempo="0"+tempo
		dummy=dummy+tempo
		next
		dummy=dummy+"0000"+chr(34)
		listing(i)=dummy
	loop
next	


rem Conversion des GR$(x) en CHR$(x+48)
rem ====================================

for i=1 to ligne

	Do while instr(listing(i),"GR$(")>0

		j=instr(listing(i),"GR$(" )
		k=instr(j,listing(i),")")
		l=MID(listing(i),j+4,k-j-4)
		m=clng(l)+decalage_symbol
				
		rem dummy=mid(listing(i),1,j-1)+"CHR$("+CSTR(m)+mid(listing(i),k,len(listing(i))-k+1)
		
		dummy=mid(listing(i),1,j-1)+CHR(34)+CHR(m)+CHR(34)+mid(listing(i),k+1,len(listing(i))-k)
		listing(i)=dummy
		
	loop
next	

rem Suppression des ";" gnrs par la conversion des GR$ en "<caractere>"
rem ===================================

tempo=chr(34)+";"+chr(34)

for i=1 to ligne
	listing(i)=replace(listing(i),tempo,"")
next



rem Conversion des LOCATE x,y,z en CURSORX x:CURSORY y
rem ==================================================

for i=1 to ligne

	Do while instr(listing(i),"LOCATE")>0
			
		j=instr(listing(i),"LOCATE" )
		k=instr(j,listing(i),",")
		n=instr(k+1,listing(i),",")
		l=MID(listing(i),j+6,k-j-6)
		
		' Cas ou il n'y a pas de troisieme parametre dans la commande LOCATE MO5
		
		if n=0 then 
			n=instr(k+1,listing(i),":")
		end if	
		
		flag_variable=false
		
		for z=1 to len(l)
			if instr("0123456789",mid(l,z,1))=0 then 
				flag_variable=true
			end if	
		next
		
		if flag_variable=true then
			m=cstr(l)
		else	
			m=cstr(clng(l))
		end if
		
		l=MID(listing(i),k+1,n-k-1)
				
		if err.number <> 0 then 
			msgbox err.description
			msgbox m+chr(13)+chr(10)+listing(i)
		end if
		
		flag_variable=false
		for z=1 to len(l)
			if instr("0123456789",mid(l,z,1))=0 then 
				flag_variable=true
			end if	
		next
		
		if flag_variable=true then
			o=cstr(l)
		else	
			o=cstr(clng(l))
		end if
				
		p=instr(n-1,listing(i),":") 
				
		if p>0 then
			dummy=mid(listing(i),1,j-1)+"CURSORX "+m+":CURSORY "+o+mid(listing(i),p,len(listing(i))-p+1)
		else
			dummy=mid(listing(i),1,j-1)+"CURSORX "+m+":CURSORY "+o
		end if
		
		listing(i)=dummy
	loop
next	


rem Conversion des RND: en RND(1):
rem ==============================

' etape 1

for i=1 to ligne

	Do while instr(listing(i),"RND:")>0
	
		j=instr(listing(i),"RND:" )
		dummy=mid(listing(i),1,j-1)+"KKK:"+mid(listing(i),j+4,len(listing(i))-j-3)
		listing(i)=dummy
	loop
next	

' etape 2

for i=1 to ligne

	Do while instr(listing(i),"KKK:")>0
	
		j=instr(listing(i),"KKK:" )
		dummy=mid(listing(i),1,j-1)+"RND(1)"+mid(listing(i),j+3,len(listing(i))-j-2)
		listing(i)=dummy
	loop
next	

rem Conversion des COLOR X,Y en EG X,Y
rem ==================================

for i=1 to ligne

	Do while instr(listing(i),"COLOR")>0

		j=instr(listing(i),"COLOR" )
		k=instr(j,listing(i),",")
		n=instr(j,listing(i),":")
						
		if n=0 then n=len(listing(i))

		if k>n then k=0  ' virgule d'une autre commande		
				
		if k>0 THEN 
		
			l=MID(listing(i),j+5,k-j-5)
						
			m=MID(listing(i),k+1,n-k-1)
			rem msgbox m+chr(13)+chr(10)+listing(i)		
			
		else
			
			n=instr(j,listing(i),":")
			m=""
			
			if n>0 then
				l=MID(listing(i),j+5,n-j-5)
			else
				l=MID(listing(i),j+5,len(listing(i))-j-4)

			end if
			
		end if
	
		if l="" then msgbox listing(i)
	
		' Couleurs entre 0 et 7 sur VG5000, 0 et 15 sur MO5
		
		if instr("0123456789",l)<>0 THEN
		
			l2=clng(l)
			
			if l2>7 then l2=l2-8
			l=cstr(l2)
		end if
		
		if m<>"" THEN
			if 	instr("0123456789",m)<>0 THEN
				m2=clng(m)
				if m2>7 then m2=m2-8
				m=cstr(m2)
			end if	
		end if
		
		n=instr(j,listing(i),":")
		
		if n>0 then 
		
			IF m<>"" THEN		
				dummy=mid(listing(i),1,j-1)+"EG"+l+","+m+mid(listing(i),n,len(listing(i))-n+1)
			else
				dummy=mid(listing(i),1,j-1)+"EG"+l+mid(listing(i),n,len(listing(i))-n+1)
			end if		
		else
		
			IF m<>"" THEN		
					dummy=mid(listing(i),1,j-1)+"EG "+l+","+m
			else
					dummy=mid(listing(i),1,j-1)+"EG "+l
			end if					
		end if
		
		'msgbox dummy+chr(10)+chr(13)+listing(i)
		listing(i)=dummy
	loop
next	

rem Conversion des SCREEN X,Y,Z en INIT X,Y
rem =======================================

for i=1 to ligne

	Do while instr(listing(i),"SCREEN")>0

		j=instr(listing(i),"SCREEN" )
		k=instr(j,listing(i),",")
		n=instr(k+1,listing(i),",")
			
		l=MID(listing(i),j+6,k-j-6)
		m=MID(listing(i),k+1,n-k-1)
		
		o=instr(k+1,listing(i),":")	
		
		if err.number <> 0 then 
			msgbox err.description
			msgbox listing(i)
		end if
			
		
		if o>0 then 		
			dummy=mid(listing(i),1,j-1)+"INIT"+l+","+m+mid(listing(i),o,len(listing(i))-o+1)
		else
			dummy=mid(listing(i),1,j-1)+"INIT"+l+","+m
		end if
		
		rem msgbox dummy+chr(10)+chr(13)+listing(i)
		listing(i)=dummy
	loop
next	


rem Suppression des CLS (pas d'equivalent direct en Basic VG5000)
rem ===================

for i=1 to ligne
	listing(i)=replace(listing(i),"CLS:","")
next


rem Commandes cosmetiques pour ameliorer la lisibilite du listing
rem =============================================================

rem Conversion des NEXTW en NEXT W
rem ==============================

for i=1 to ligne
	listing(i)=replace(listing(i),"NEXTW","NEXT W")
next	

rem Conversion des FORW= en FOR W=
rem ==============================

for i=1 to ligne
	listing(i)=replace(listing(i),"FORW=","FOR W=")
next	

rem Conversion des THENCURSOR en THEN CURSOR
rem ==============================

for i=1 to ligne
	listing(i)=replace(listing(i),"THENCURSOR","THEN CURSOR")
next	

rem Conversion des THENPRINT en THEN PRINT
rem ======================================

for i=1 to ligne
	listing(i)=replace(listing(i),"THENPRINT","THEN PRINT")
next	

rem Conversion des PRINTW en PRINT W
rem ================================

for i=1 to ligne
	listing(i)=replace(listing(i),"PRINTW","PRINT W")
next	

rem Conversion des PRINTCHR$ en PRINT CHR$
rem ======================================

for i=1 to ligne
	listing(i)=replace(listing(i),"PRINTCHR$","PRINT CHR$")
next	

rem Conversion des =1TO en PRINT =1 TO 
rem ===================================

for i=1 to ligne
	listing(i)=replace(listing(i),"=1TO","=1 TO ")
next	

rem Conversion des =0TO en PRINT =0 TO 
rem ===================================

for i=1 to ligne
	listing(i)=replace(listing(i),"=0TO","=0 TO ")
next	

rem Conversion des GOSUB en GOSUB
rem ==============================

for i=1 to ligne
	listing(i)=replace(listing(i),"GOSUB","GOSUB ")
next	

rem Conversion des IFR$= en IF R$=
rem ==============================

for i=1 to ligne
	listing(i)=replace(listing(i),"IFR$=","IF R$=")
next	

for i=1 to ligne
	listing(i)=replace(listing(i),"IFR$=","IF R$=")
next	


rem Remplacement de R$=INKEY$:U=RND(1): par GOSUB 15000:
rem ====================================================

for i=1 to ligne
	listing(i)=replace(listing(i),"R$=INKEY$:U=RND(1):","GOSUB 15000:")
next

rem Suppression de :CURSORX 0:CURSORY 0
rem ===================================

for i=1 to ligne
	listing(i)=replace(listing(i),":CURSORX 0:CURSORY 0","")
next

' Sauvegarde du listing modifie
' La sauvegarde teste la longueur des lignes et les coupe en deux si elles
' depassent 1Z8 caracteres, limite du VG5000

set destinationfile=fso.CreateTextFile(file_destination,TRUE)

For i=1 to ligne

	' si la ligne est trop longue, on la coupe en deux...

	if len(listing(i))>longueur_ligne THEN 
	
		for j=longueur_ligne-1 TO 1 step -1
		
			if mid(listing(i),j,1)=":" then 
				coupe=j
				j=1
			end if	
				
		next		

		' il ya toujours un ":" dans les lignes "longues", on se s'emmmerde pas a faire un test

		' on recupere le numero de ligne	
		
		j=instr(listing(i)," ")	
		tempo=mid(listing(i),1,j-1)	
		tempo2=clng(tempo)+1
		tempo=cstr(tempo2)
		
		tempo=tempo+" "+mid(listing(i),coupe+1,len(listing(i))-j)
		rem msgbox tempo
		listing(i)=mid(listing(i),1,coupe-1)
		
		destinationfile.writeline(listing(i))
		destinationfile.writeline(tempo)

	else
		destinationfile.writeline(listing(i))
	end if
	
next

destinationfile.close		

msgbox "Traitement termin. Penser  rajouter les lignes de code en 15000."